/***************************************************************************
                          ktritoc  -  a KDE game ai.h
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef AI_H
#define AI_H

#include <qobject.h>
#include <qtimer.h>
#ifdef USEKDE
#include <qmemarray.h>
#else
#include <qarray.h>
#define QMemArray QArray
#endif



class KtritocDoc;

/**Computer player
  *@author M. Heni
  */

struct Tupel
{
  int a,b,c;
};  

class Ai : public QObject
{
   Q_OBJECT

public:
  Ai(KtritocDoc *doc);
  ~Ai();
  /** Let the Ai throw the dice */
  void throwDice();
  /** Let the Ai make a move */
  void makeMove(int player);
  /** Stops current AI move */
  void stop();

protected:
  /** Search and perform Ai move */
  void searchMove();
  /** Calculate board value */
  int calc_value(QMemArray<int> &field,int player, int& winner, bool check_won);

protected slots:
  /** Perform AI action */
  void action();

private: // Private attributes
  KtritocDoc *mDoc;
  QTimer *mTimer;
  int mPlayer;
  int mAction; // What actuon to perform
  QMemArray<Tupel> mLines; // Row combinations to win
};

#endif
