/***************************************************************************
    Border of the fields
                          
    copyright            : (C) 2002 by Martin Heni
    email                : martin@heni-online.de
 ***************************************************************************/
#ifndef GEOMETRYSPRITES_H
#define GEOEMTRYSPRITES_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qcanvas.h>
#include <qpainter.h>
#include <qsize.h>

/**
 * Draw the field boarder via self made lines
 * in the sprites "drawShape" function
 *
 */
class BorderSprite : public QCanvasPolygon
{
  public:
    /**
     * Construct the piece
     * @param canvas - the canvas
     */
    BorderSprite(QCanvas *Canvas,QSize size, QColor color,QColor backcolor);

    /**
     * Destructor for the line
     */
    ~BorderSprite();

    /**
     * Rtti for the line sprite
     */
    virtual int rtti() const {return 2012;} 

  protected:
    /**
     * For a polygon which shall have a user defined look
     * we overwrite the function of the QT canvas library.
     * This code allows us to paint what ever we like. For
     * details see the Qt documentation
     * @param p - the painter to paint
     */
 //   void draw(QPainter &p);
    void drawShape(QPainter &p);
  /** No descriptions */



    private:
    QColor mColor;
    QColor mBackColor;
};
#endif
