/***************************************************************************
                          ktritoc  -  a KDE game gameinfo.h
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAMEINFO_H
#define GAMEINFO_H

#include <qobject.h>
#include <qcanvas.h>
#include <qpoint.h>
#include <qtimer.h>

#define GAMEINFO_TIMEOUT  5000 /* msec */

#define GAMEINFO_THROWDICE   0
#define GAMEINFO_MAKEMOVE1    1
#define GAMEINFO_MAKEMOVE2    2
#define GAMEINFO_REMOVE_YELLOW 3
#define GAMEINFO_REMOVE_RED 4
#define GAMEINFO_NOMOVE  5

#define GAMEINFO_AMOUNT  6  /* one more than last message */

class Sprite;
class NumberSprite;

/**Shows game information
  *@author M. Heni
  */

class GameInfo : public QObject
{
   Q_OBJECT

public:
  GameInfo();
  ~GameInfo();
  /** Sets widget offset */
  void setOffset(QPoint offset);
  /** Deletes sprites */
  void clear();
  /** Adds info sprite */
  void AddInfo(QCanvas *canvas,QString info);
  /** Shows info icon and text */
  void setInfo(int no,QString text, int timeout=0);
  /** Resets info */
  void reset();

protected slots:
  /** hides the sprites */
  void hideInfo();

private: // Private attributes
  /** Widget offset */
  QPoint mOffset;

  Sprite * mInfoSprite;
  NumberSprite *mInfoText;
  QTimer *mTimer;
};

#endif
