/***************************************************************************
                          ktritoc  -  a KDE game gameintro.h
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAMEINTRO_H
#define GAMEINTRO_H

#include <qcanvas.h>
#include <qobject.h>
#include <qtimer.h>

#ifdef USEKDE
#include <qptrlist.h>
#else
#include <qlist.h>
#define QPtrList QList
#endif


#include "mrandom.h"

class MoveSprite;

/**
  * Creates an intro animation for the game
  *@author M. Heni
  */

class GameIntro : public QObject
{
  Q_OBJECT

public: 
	GameIntro();
	~GameIntro();
  /** Loads and prepares the intro sprites */
  void LoadIntro(QCanvas *canvas,QString piece,QString intro);
  /** Starts the intro animation */
  void StartIntro();

protected slots:
  /** Starts gravity removal */
  void start_remove();

private:
   QPtrList<MoveSprite> mSpriteList;
   MRandom mRandom;
   int mMode; // Animation step mode
   QTimer *mTimer;
   QCanvas * mCanvas;
};

#endif
