/***************************************************************************
                          ktritoc  -  a KDE game gameover.cpp
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
  ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtimer.h>

#ifdef USEKDE
#include <kdebug.h>
#include <stdlib.h>
#endif

#include "gameover.h"
#include "movesprite.h"
#include "geometry.h"


#ifdef USE_KDE
#define ANIMATION_DELAY 3 
#define TIME_TO_ROTATE 4500.0 // ms
#else
#define ANIMATION_DELAY 8 
#define TIME_TO_ROTATE 6500.0 // ms
#endif


GameOver::GameOver() : QObject(0,"gameover")
{
  mSprite = 0;

}

GameOver::~GameOver()
{
}

void GameOver::setOffset(QPoint offset)
{
  mOffset = offset;
}

void GameOver::clear()
{
  if (mSprite)
  {
    delete mSprite;
    mSprite = 0;
  }
}


/** Adds info sprite */
void GameOver::AddSprite(QCanvas *canvas,QString name)
{
  MoveSprite *sprite =   new MoveSprite(canvas,name,GAMEOVER_AMOUNT);
  #ifdef USEKDE
  if (!sprite) {kdError() << "Cannot load sprite "<<name<<endl;exit(1);}
  #else
  if (!sprite) return ;
  #endif
  mSprite = sprite;
  sprite->move(mOffset.x() ,mOffset.y());
  sprite->setVelocity(0.0,0.0);
  sprite->setZ(70);
}

/** Stops the game over animation */
void GameOver::StopGameOver()
{
  if (!mSprite) return ;
  mSprite->setAnimation(0);
  mSprite->hide();
}

/** Starts the game over animation */
void GameOver::StartGameOver()
{
  if (!mSprite) return ;
  mSprite->move(mOffset.x() ,mOffset.y());
  mSprite->setDestination(GAMEOVER_DEST_X,GAMEOVER_DEST_Y);
  mSprite->setVelocity(GAMEOVER_VX*VELOCITY_MULTI,GAMEOVER_VY*VELOCITY_MULTI);
  QTimer::singleShot(TIME_TO_ROTATE,this,SLOT(slotStartRotation()));
  mSprite->setMovement(2,0.0);
}

/** QPE: Starts the rotation a bit delayed
  */
void GameOver::slotStartRotation()
{
#ifdef USEKDE
  if (!mSprite || !mSprite->isVisible() ) return; 
#else  
  if (!mSprite || !mSprite->visible() ) return; 
#endif  
  mSprite->setAnimation(ANIMATION_DELAY);
}

#ifdef USEKDE
#include "gameover.moc"
#endif
