/***************************************************************************
                          ktritoc  -  a KDE game gameover.h
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAMEOVER_H
#define GAMEOVER_H

#include <qobject.h>
#include <qcanvas.h>
#include <qpoint.h>
#include <qtimer.h>

class MoveSprite;

/**Shows game over
  *@author M. Heni
  */

class GameOver : public QObject
{
   Q_OBJECT

public:
  GameOver();
  ~GameOver();
  /** Sets widget offset */
  void setOffset(QPoint offset);
  /** Deletes sprites */
  void clear();
  /** Adds info sprite */
  void AddSprite(QCanvas *canvas,QString name);
  /** Starts the game over animation */
  void StartGameOver();
  /** Stops the game over animation */
  void StopGameOver();

protected slots:
  /** delayed rotation (QPE) */
  void slotStartRotation();

private: // Private attributes
  /** Widget offset */
  QPoint mOffset;

  MoveSprite * mSprite;
};

#endif
