#ifndef GEOMETRY_H
#define GEOMETRY_H

#define VELOCITY_MULTI 2.0

// Number of fields
// Board geometry
#define SIZE_BOARD_X   3
#define SIZE_BOARD_Y   3
#define BOARD_AMOUNT  9

// Field geometry
#define SIZE_FIELD_X   3
#define SIZE_FIELD_Y   3
#define FIELD_AMOUNT  9

// Dice geometry
#define DICE_MAXNUMBER 12  // dice throw till 12
#define DICE_AMOUNT    2   // two dice used (min number=2)

// Dice
#define DICE_SIZE  6  // dice frames
#define DICE_X   50   // Size of dice
#define DICE_Y   50
#define MAX_COUNT 3  // So many throwing of dice
#define TIMER_COUNT 100 // Timer delay for animation
#define DICE_OFFSET_X   216   // Offset of dice
#define DICE_OFFSET_Y   494
#define MAX_DICE_CHANGES 5  // Game over after 3 impossible moves

// Board 
#define BOARD_X 140    // Board size
#define BOARD_Y 140
#define BOARD_OFFSET_X     22  // offset
#define BOARD_OFFSET_Y     6
#define BOARD_V_OFFSET 60.0   // Speed for explosion
#define BOARD_V_RND    70.0


//Field
#define FIELD_X   40     // Field size
#define FIELD_Y   40
#define FIELD_OFFSET_X     32 // offset
#define FIELD_OFFSET_Y     32
#define FONTSIZE           12
#define NUMBER_OFFSET_X   18  // Offset of centered text
#define NUMBER_OFFSET_Y   18
#define MOUSE_OFFSET_X -16
#define MOUSE_OFFSET_Y -20

// Colors
#define COL_BOARD    QColor(54,54,160)
#define COL_BORDER  QColor(96,96,192)
#define COL_BACK  QColor(0,0,128)

#define BOARD_ROWS   3   // 3 x 3
#define FIELD_ROWS   3   // 3 x 3

// Digits and sprite relative to score widget
#define DIGIT_X  24                // spacing 
#define DIGIT_OFFSET_X -36         // digit offset
#define DIGIT_PLAYER_OFFSET_X -52  // sprite offset
#define DIGIT_PLAYER_OFFSET_Y -12


// score widget
#define SCORE_OFFSET_X 86
#define SCORE_OFFSET_Y 466
#define SCORE_X 292
#define DOLLAR_OFFSET_X 0
#define DOLLAR_OFFSET_Y 0
#define DOLLAR_OFFSET_DX 130
#define DOLLAR_OFFSET_DY -600
#define DOLLAR_VX       0.70
#define DOLLAR_VY       -4.0

// Game Over
#define GAMEOVER_OFFSET_X 240
#define GAMEOVER_OFFSET_Y 20
#define GAMEOVER_DEST_X   220
#define GAMEOVER_DEST_Y   250
#define GAMEOVER_VX       0
#define GAMEOVER_VY       1.2
#define GAMEOVER_AMOUNT   15

// Info
#define INFO_OFFSET_X 178
#define INFO_OFFSET_Y 454

#define INFO_OFFSET_SPRITE_X 0
#define INFO_OFFSET_SPRITE_Y 0
#define INFO_OFFSET_TEXT_X 20
#define INFO_OFFSET_TEXT_Y -12
#define INFO_FONTSIZE 14


// Intro
#define INTRO_V_OFFSET 50.0   // Speed for explosion
#define INTRO_V_RND    90.0
#define INTRO_LINEAR_DURATION_FACTOR  120.0 // seconds for linear




#endif
