/***************************************************************************
                          ktritoc  -  a KDE game ktritoc.cpp
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
  ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// #include <stream.h>

#undef SHAREWARE   // Use nag screens

// include files for QT
#include <qdir.h>

// include files for KDE
#ifdef USEKDE
// #include <kiconloader.h>
//#include <kfiledialog.h>
#include <kapp.h>
#include <kstandarddirs.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <klocale.h>
#include <kconfig.h>
#include <kstdaction.h>
#include <kdebug.h>
#include <kmessagebox.h>
#include <kaccel.h>
#include <kaction.h>
#include <kurl.h>
#else
#include <qaccel.h>
#include <qmsgbox.h>
#include <qmenubar.h>
#include <qwhatsthis.h>
#include <qmessagebox.h>
#include "kconfig.h"
#define i18n tr
#undef ONLINE_HELP
#endif

// application specific includes
#include "ktritoc.h"
#include "ktritocview.h"
#include "ktritocdoc.h"

#define ID_STATUS_MSG 1

#define ACTION(x)   (actionCollection()->action(x))

#define GAME_TITLE "KTritoc"


#ifdef USEKDE
KtritocApp::KtritocApp(QWidget* , const char* name):KMainWindow(0, name)
#else
KtritocApp::KtritocApp(QPEApplication *app) : KMainWindow(0)
#endif
{
  #ifdef USEKDE
  config=kapp->config();

  #ifdef NO__SRCDIR
    kdDebug() << "SRCDIR=" << SRCDIR << endl;
    KGlobal::dirs()->addResourceDir("data", SRCDIR + QString::fromLatin1("/../pics"));
    KGlobal::dirs()->addResourceDir("data", SRCDIR + QString::fromLatin1("/.."));
    mGrafixDir=kapp->dirs()->findResourceDir("data","intro.png");
    // QStringList aa=KGlobal::dirs()->resourceDirs("data");
    // for ( QStringList::Iterator it = aa.begin(); it != aa.end(); ++it ) {
    // kdDebug() << *it << ":"<<endl;
    // }
  #else
    QString file="ktritoc/pics/intro.png";
    mGrafixDir=kapp->dirs()->findResourceDir("data",file);
    if (mGrafixDir.isNull()) mGrafixDir="pics/";
    else mGrafixDir+="ktritoc/pics/";
  #endif
    kdDebug() << "Localised grafix_dir=" << mGrafixDir << endl;
  #else
  mApp=app;
  config=new KConfig("tritoc",KConfig::User);
  mGrafixDir=QString("%1pics/tritoc/").arg(mApp->qpeDir());
  // mGrafixDir=QString("/home/martin/zaurus/qpe/tritoc/pics/");
  // cout << "mGrafixDir=" << mGrafixDir  << endl;
  #endif

  #ifdef SHAREWARE
  mTimer = new QTimer(this);
  mTimer->stop();
  connect(mTimer,SIGNAL(timeout()), this,SLOT(msg_screen()));
  #endif

  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initStatusBar();
  initActions();
  initDocument();
  initView();
	
  readOptions();

  checkMenus();

  #ifdef USEKDE
  resize( 470, 592 );
  #endif
}

KtritocApp::~KtritocApp()
{
#ifndef USEKDE
  // Put the saveProperties here unless we find out how
  // to put an OK button into the application
  saveProperties(config);
  delete config;
#endif

  #ifdef SHAREWARE
  if (mTimer) delete mTimer;
  #endif

}

void KtritocApp::initActions()
{
  QStringList list;
  QString dots("...");
  #ifdef USEKDE

  // Start new game
  (void)KStdAction::openNew(this, SLOT(slotFileNew()), actionCollection(), "file_new");
  ACTION("file_new")->setStatusText(i18n("Start a new game")+dots);
  ACTION("file_new")->setWhatsThis(i18n("Start a new game"));

  // Shows highscores
  /* TODO: No highscore used
  (void)new KAction(i18n("&Show Highscores..."),"flag", 0, this, SLOT(slotFileHighscores()),
                      actionCollection(), "game_statistics");
  ACTION("game_statistics")->setStatusText(i18n("Show highscores for the current level")+dots);
  ACTION("game_statistics")->setWhatsThis(i18n("Show highscores for the current level"));
  */

  (void)new KAction(i18n("&Clear score..."),"flag", 0, this, SLOT(slotFileClearScore()),
                      actionCollection(), "file_clearscore");
  ACTION("file_clearscore")->setStatusText(i18n("Clear the game scores")+dots);
  ACTION("file_clearscore")->setWhatsThis(i18n("Clear the game scores"));

  // Quits the program
  (void)KStdAction::quit(this, SLOT(slotFileQuit()), actionCollection(), "file_quit");
  ACTION("file_quit")->setStatusText(i18n("Quits the program")+dots);
  ACTION("file_quit")->setWhatsThis(i18n("Quits the program"));


 // Select the startplayer
 (void)new KSelectAction(i18n("Startplayer"),0,this,SLOT(slotSettingsStartplayer()),
                      actionCollection(), "settings_startplayer");
  ACTION("settings_startplayer")->setStatusText(i18n("Select who starts the game")+dots);
  ACTION("settings_startplayer")->setWhatsThis(i18n("Select who starts the game"));
  list.clear();
  list.append(i18n("&Yellow"));
  list.append(i18n("&Red"));
  ((KSelectAction *)ACTION("settings_startplayer"))->setItems(list);

 // Select the computerplayer

 (void)new KToggleAction(i18n("Ai plays &yellow"),0,this,SLOT(slotSettingsAiYellow()),
                      actionCollection(), "settings_aiyellow");
  ACTION("settings_aiyellow")->setStatusText(i18n("Computer plays yellow")+dots);
  ACTION("settings_aiyellow")->setWhatsThis(i18n("Computer plays yellow"));
 (void)new KToggleAction(i18n("Ai plays &red"),0,this,SLOT(slotSettingsAiRed()),
                      actionCollection(), "settings_aired");
  ACTION("settings_aired")->setStatusText(i18n("Computer plays red")+dots);
  ACTION("settings_aired")->setWhatsThis(i18n("Computer plays red"));

/** DONE BY the XML GUI 
 (void)new KActionMenu(i18n("Ai"), actionCollection(), "settings_computerplayer");
  ACTION("settings_computerplayer")->setStatusText(i18n("Select the computer player")+dots);
  ACTION("settings_computerplayer")->setWhatsThis(i18n("Select the computer player"));
 ((KActionMenu *)ACTION("settings_computerplayer"))->insert(ACTION("settings_aiyellow"));
 ((KActionMenu *)ACTION("settings_computerplayer"))->insert(ACTION("settings_aired"));
**/ 
  

 // Set the level
 (void)new KSelectAction(i18n("Level"),0,this,SLOT(slotSettingsLevel()),
                      actionCollection(), "settings_level");
  ACTION("settings_level")->setStatusText(i18n("Set the level")+dots);
  ACTION("settings_level")->setWhatsThis(i18n("Set the level"));
  list.clear();
  list.append(i18n("Very easy yellow"));
  list.append(i18n("Easy yellow"));
  list.append(i18n("Normal"));
  list.append(i18n("Easy red"));
  list.append(i18n("Very easy red"));
  ((KSelectAction *)ACTION("settings_level"))->setItems(list);

 // Set the length of the game
 (void)new KSelectAction(i18n("Duration"),0,this,SLOT(slotSettingsDuration()),
                      actionCollection(), "settings_duration");
  ACTION("settings_duration")->setStatusText(i18n("Set the game duration")+dots);
  ACTION("settings_duration")->setWhatsThis(i18n("Set the game duration"));
  list.clear();
  list.append(i18n("1 game"));
  list.append(i18n("3 games"));
  list.append(i18n("5 games"));
  list.append(i18n("10 games "));
  list.append(i18n("25 games"));
  list.append(i18n("50 games"));
  ((KSelectAction *)ACTION("settings_duration"))->setItems(list);

 // Set the dice statistics
 (void)new KSelectAction(i18n("Dice"),0,this,SLOT(slotSettingsDice()),
                      actionCollection(), "settings_dice");
  ACTION("settings_dice")->setStatusText(i18n("Choose dice statistics")+dots);
  ACTION("settings_dice")->setWhatsThis(i18n("Choose dice statistics"));
  list.clear();
  list.append(i18n("&Two standard dice"));
  list.append(i18n("&Equal numbers"));
  ((KSelectAction *)ACTION("settings_dice"))->setItems(list);

 // View Statusbar
 (void)KStdAction::showStatusbar(this, SLOT(slotViewStatusBar()), actionCollection(),"view_statusbar");
 //(void)new KToggleAction(i18n("View &Statusbar"),0,this,SLOT(slotViewStatusBar()),
 //                     actionCollection(), "view_statusbar");
  ACTION("view_statusbar")->setStatusText(i18n("Toggle the statusbar")+dots);
  ACTION("view_statusbar")->setWhatsThis(i18n("Toggle the statusbar"));

  // use the absolute path to your ktritocui.rc file for testing purpose in createGUI();
  //  createGUI("/home/cvs/kdegames/ktritoc/ktritocui.rc", false);
  createGUI(QString::null, false);

  if (toolBar()) toolBar()->hide();

 #else // ---------------- QPE -----------------
  // Now build the menu bar ---------
  fileMenu=new QPopupMenu();
  // --------------- FILE ---------------------
  fileNew = new MAction(tr("New Game"), tr("&New"),
                        Qt::Key_Space, this);
  #ifdef ONLINE_HELP
  fileNew->setStatusTip(tr("Start a new Game"));
  fileNew->setWhatsThis(tr("New Game\n\nStart a new Game"));
  #endif
  fileNew->setEnabled(true);
  connect(fileNew, SIGNAL(activated()), this, SLOT(slotFileNew()));
  fileNew->addTo(fileMenu);

  fileClearScore = new MAction(tr("Clear score"),
                              tr("&Clear score..."),
                              QAccel::stringToKey(tr("Ctrl+h")), this);
  #ifdef ONLINE_HELP
  fileClearScore->setStatusTip(tr("Clear the game scores"));
  fileClearScore->setWhatsThis(tr("Clear the game scores"));
  #endif
  connect(fileClearScore, SIGNAL(activated()), this, SLOT(slotFileClearScore()));
  fileClearScore->addTo(fileMenu);

  // Separator ----
  fileMenu->insertSeparator();

  fileQuit = new MAction(tr("Exit"), tr("E&xit"), 0, this);
  #ifdef ONLINE_HELP
  fileQuit->setStatusTip(tr("Quits the application"));
  fileQuit->setWhatsThis(tr("Exit\n\nQuits the application"));
  #endif
  connect(fileQuit, SIGNAL(activated()), this, SLOT(slotFileQuit()));
  fileQuit->addTo(fileMenu);


  // --------------- SETTINGS -----------------
  // menuBar entry settingsMenu
  settingsMenu=new QPopupMenu();

  // submenu ---- startplayer ----
  startplayerMenu=new QPopupMenu();
  settingsMenu->insertItem(i18n("Startplayer"),startplayerMenu);

  settingsStartplayer = new MActionGroup(this);
  #ifdef ONLINE_HELP
  settingsStartplayer->setStatusTip(tr("Select who starts the game"));
  settingsStartplayer->setWhatsThis(tr("StartPlayer\n\nSelect who starts the game"));
  #endif
  settingsStartplayer->setExclusive( true );
  connect(settingsStartplayer, SIGNAL( signalActionSelected() ),
           this, SLOT( slotSettingsStartplayer() ) );
  list.clear();
  list.append(i18n("&Yellow"));
  list.append(i18n("&Red"));
  settingsStartplayer->insertAction(startplayerMenu,"settingsStartplayer",list);

  // submenu ---- Ai ----
  computerplayerMenu=new QPopupMenu();
  settingsMenu->insertItem(i18n("Computer player"),computerplayerMenu);

  settingsComputerplayer = new MActionGroup(this);
  #ifdef ONLINE_HELP
  settingsComputerplayer->setStatusTip(tr("Select who the computer plays"));
  settingsComputerplayer->setWhatsThis(tr("Computer Player\n\nSelect who the computer player"));
  #endif
  settingsComputerplayer->setExclusive( false );
  connect(settingsComputerplayer, SIGNAL( signalActionSelected() ),
           this, SLOT( slotSettingsComputerplayer() ) );
  list.clear();
  list.append(i18n("Ai plays &yellow"));
  list.append(i18n("Ai plays &red"));
  settingsComputerplayer->insertAction(computerplayerMenu,"settingsComputerplayer",list);

  // submenu ---- level ----
  levelMenu=new QPopupMenu();
  settingsMenu->insertItem(i18n("Level"),levelMenu);

  settingsLevel = new MActionGroup(this);
  #ifdef ONLINE_HELP
  settingsLevel->setStatusTip(tr("Set the level"));
  settingsLevel->setWhatsThis(tr("Level\n\nSet the level"));
  #endif
  settingsLevel->setExclusive( true );
  connect(settingsLevel, SIGNAL( signalActionSelected() ),
           this, SLOT( slotSettingsLevel() ) );
  list.clear();
  list.append(i18n("Very easy yellow"));
  list.append(i18n("Easy yellow"));
  list.append(i18n("Normal"));
  list.append(i18n("Easy red"));
  list.append(i18n("Very easy red"));
  settingsLevel->insertAction(levelMenu,"settingsLevel",list);

  // submenu ---- dice ----
  diceMenu=new QPopupMenu();
  settingsMenu->insertItem(i18n("Dice"),diceMenu);

  settingsDice = new MActionGroup(this);
  #ifdef ONLINE_HELP
  settingsDice->setStatusTip(tr("Choose dice statistics"));
  settingsDice->setWhatsThis(tr("Dice\n\nChoose dice statistics"));
  #endif
  settingsDice->setExclusive( true );
  connect(settingsDice, SIGNAL( signalActionSelected() ),
           this, SLOT( slotSettingsDice() ) );
  list.clear();
  list.append(i18n("&Two standard dice"));
  list.append(i18n("&Equal numbers"));
  settingsDice->insertAction(diceMenu,"settingsDice",list);


  // --------------- HELP ---------------------
  // menuBar entry helpMenu
  helpMenu=new QPopupMenu();

  helpAboutApp = new MAction(tr("About"), tr("&About..."),
                             QAccel::stringToKey("Ctrl+a"), this);
  #ifdef ONLINE_HELP
  helpAboutApp->setStatusTip(tr("About the application"));
  helpAboutApp->setWhatsThis(tr("About\n\nAbout the application"));
  #endif
  connect(helpAboutApp, SIGNAL(activated()), this, SLOT(slotHelpAbout()));
  helpAboutApp->addTo(helpMenu);


  ///////////////////////////////////////////////////////////////////
  // MENUBAR CONFIGURATION
  menuBar()->insertItem(tr("&File"), fileMenu);
  menuBar()->insertItem(tr("&Settings"), settingsMenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("&Help"), helpMenu);


 #endif // KDE or QPE
}

void KtritocApp::initStatusBar()
{
  #ifdef USEKDE
  // STATUSBAR
  statusBar()->insertItem(i18n("Ready."), ID_STATUS_MSG);
  #endif
}

void KtritocApp::initDocument()
{
  doc = new KtritocDoc(this);
  connect(doc,SIGNAL(signalGameOver(int)),
                this, SLOT(slotGameOver(int)) );
}

void KtritocApp::initView()
{ 
  // create the main widget here that is managed by KTMainWindow's view-region and
  // connect the widget to your document to display document contents.

  view = new KtritocView(this);
  view->setGrafix(mGrafixDir);
  doc->setView(view);
  setCentralWidget(view);	
  #ifdef USEKDE
  setPlainCaption(GAME_TITLE);
  #else
  setCaption(GAME_TITLE);
  setFocusPolicy( StrongFocus );
  #endif

}


KtritocDoc *KtritocApp::getDocument() const
{
  return doc;
}

void KtritocApp::saveOptions()
{	
  // We moved the QPE saveOptions to the destructor as
  // we do not know how to switch between OK and X buttons
  #ifdef USEKDE
  config->setGroup("General Options");
  config->writeEntry("Geometry", size());
  config->writeEntry("Show Statusbar",((KToggleAction *)ACTION("view_statusbar"))->isChecked());
  saveProperties(config);
  #endif
}


void KtritocApp::readOptions()
{
  config->setGroup("General Options");

  #ifdef USEKDE
  // bar status settings
  bool bViewStatusbar = config->readBoolEntry("Show Statusbar", true);
  ((KToggleAction *)ACTION("view_statusbar"))->setChecked(bViewStatusbar);
  slotViewStatusBar();

  QSize size=config->readSizeEntry("Geometry");
  if(!size.isEmpty())
  {
    resize(size);
  }
  #endif

  readProperties(config);
}

void KtritocApp::saveProperties(KConfig *_cfg)
{
  getDocument()->saveProperties(_cfg);
}


void KtritocApp::readProperties(KConfig* _cfg)
{
  getDocument()->readProperties(_cfg);
}

bool KtritocApp::queryClose()
{
  return true;
}

bool KtritocApp::queryExit()
{
  saveOptions();
  return true;
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void KtritocApp::slotFileNew()
{
  slotStatusMsg(i18n("Creating new document..."));

  #ifdef SHAREWARE
  if (mTimer) mTimer->start(1000*60,false);
  msg_screen();
  #endif
  

  if (doc->isRunning())
  {
    QString title = i18n("Start new game");
    QString msg   = i18n("The current game is still running.\nDo you really want to start\na new game?\n");
    #ifdef USEKDE
    int ret = KMessageBox::questionYesNo(this,msg,title);
    if(ret == KMessageBox::Yes)
    {
      doc->newGame();
    }
    #else
    int ret = QMessageBox::information(this,title,msg,
                            i18n("Yes"),i18n("No"),QString::null,
                            1 /* default */,1 /* Escape */);
    if(ret == 0)
    {
      doc->newGame();
    }
    #endif
  }
  else // Not RUNNING do it without query
  {
    doc->newGame();
  }


  slotStatusMsg(i18n("Ready."));
}


void KtritocApp::slotFileQuit()
{
  slotStatusMsg(i18n("Exiting..."));
  saveOptions();
  // close the first window, the list makes the next one the first again.
  // This ensures that queryClose() is called on each window to ask for closing
  if (view) view->close();
  close();
}


void KtritocApp::slotViewStatusBar()
{
  #ifdef USEKDE
  slotStatusMsg(i18n("Toggle the statusbar..."));
  //turn Statusbar on or off
  if(!((KToggleAction *)ACTION("view_statusbar"))->isChecked())
  {
    statusBar()->hide();
  }
  else
  {
    statusBar()->show();
  }
  slotStatusMsg(i18n("Ready."));
  #endif
}


void KtritocApp::slotStatusMsg(const QString &text)
{
  // change status message permanently
  #ifdef USEKDE
  statusBar()->clear();
  statusBar()->changeItem(text, ID_STATUS_MSG);
  #endif
}

/** Shows the highscore dialog */
void KtritocApp::slotFileHighscores()
{
}

/** Clear game scores */
void KtritocApp::slotFileClearScore()
{
  QString title = i18n("Clear scores");
  QString msg   = i18n("Do you really want to\ndelete all game scores?\n");
  #ifdef USEKDE
  int ret = KMessageBox::questionYesNo(this,msg,title);
  if(ret == KMessageBox::Yes)
  {
    getDocument()->resetScores();
  }
  #else
  int ret = QMessageBox::information(this,title,msg,
                          i18n("Yes"),i18n("No"),QString::null,
                          1 /* default */,1 /* Escape */);
  if(ret == 0)
  {
    getDocument()->resetScores();
  }
  #endif
}

/** Selects the startplayer */
void KtritocApp::slotSettingsStartplayer()
{
  #ifdef USEKDE
  int i=((KSelectAction *)ACTION("settings_startplayer"))->currentItem();
  #else 
  int i=settingsStartplayer->currentItem();
  #endif
  getDocument()->setStartplayer(1+i);
}

/** Selects the level */
void KtritocApp::slotSettingsLevel()
{
  #ifdef USEKDE
  int i=((KSelectAction *)ACTION("settings_level"))->currentItem();
  #else 
  int i=settingsLevel->currentItem();
  #endif
  getDocument()->setLevel(i-2); //-2,-1,0(default),1,2
}

/** Selects the amount of games */
void KtritocApp::slotSettingsDuration()
{
  #ifdef USEKDE
  int i=((KSelectAction *)ACTION("settings_duration"))->currentItem();
  #else 
  int i=0; // not supported
  #endif
  int no=1;
  if (i==0) no=1; 
  else if (i==1) no=3; 
  else if (i==2) no=5; 
  else if (i==3) no=10; 
  else if (i==4) no=25; 
  else if (i==5) no=50; 
  getDocument()->setMaxGames(no);
}

/** Change of computer player (QPE) */
void KtritocApp::slotSettingsComputerplayer()
{
  #ifndef USEKDE
  int i=settingsComputerplayer->currentItem();
  if (i==0) slotSettingsAiYellow();
  else slotSettingsAiRed();
  #endif
}

/** Selects the yellow ai mode */
void KtritocApp::slotSettingsAiYellow()
{
  #ifdef USEKDE
  bool i=((KToggleAction *)ACTION("settings_aiyellow"))->isChecked();
  #else 
  bool i=settingsComputerplayer->currentAction()->isOn();
  #endif
  getDocument()->setAiMode(1,i);
}

/** Selects the red ai mode */
void KtritocApp::slotSettingsAiRed()
{
  #ifdef USEKDE
  bool i=((KToggleAction *)ACTION("settings_aired"))->isChecked();
  #else 
  bool i=settingsComputerplayer->currentAction()->isOn();
  #endif
  getDocument()->setAiMode(2,i);
}

/** Selects the dice mode */
void KtritocApp::slotSettingsDice()
{
  #ifdef USEKDE
  int i=((KSelectAction *)ACTION("settings_dice"))->currentItem();
  #else 
  int i=settingsDice->currentItem();
  #endif
  getDocument()->setDiceMode(i);
}

void KtritocApp::slotHelpAbout()
{
  #ifndef USEKDE
  QString title = i18n("About...");
  QString msg = i18n(
  "KTritoc is a nice little boardgame\n"
  "requiring both luck and a good\n"
  "strategy to win against the computer\n"
  "or another player.\n\n"
  "Try to get three pieces and three\n"
  "boards into a row, column or a\n"
  "diagonal to win.\n\n"
  "Version %1\n(c) 2002 by Martin Heni"
  ).arg((double)GAME_VERSION,0,'f',2);
  QMessageBox::about(this,title,msg);
  #endif
}


void KtritocApp::slotGameOver(int /*winner*/)
{
  #ifdef SHAREWARE
  mTimer->stop();
  #endif

  // Switch start player
  int start = getDocument()->getStartplayer();
  start = 3-start;
  getDocument()->setStartplayer(start);

  // Check highscore
  /* TODO: No highscore used
  if (getDocument()->gameMaxReached())
  {
    getDocument()->resetScores();
  }
  */

  // Set new menu checks
  checkMenus();
}

/** Sets all menu settings to the current values of
 * the document
 */
void KtritocApp::checkMenus()
{
  int no;
  bool flag;

  // Startplayer
  no = getDocument()->getStartplayer()-1;  
  #ifdef USEKDE
  ((KSelectAction *)ACTION("settings_startplayer"))->setCurrentItem(no);
  #else
  settingsStartplayer->setCurrentItem(no);
  #endif

  // Level
  no = getDocument()->getLevel()+2;  
  #ifdef USEKDE
  ((KSelectAction *)ACTION("settings_level"))->setCurrentItem(no);
  #else
  settingsLevel->setCurrentItem(no);
  #endif

  // Duration
  int tmpno = getDocument()->getMaxGames();  
  if (tmpno == 50) no = 5;
  else if (tmpno==25) no = 4;
  else if (tmpno == 10) no = 3;
  else if (tmpno == 5) no = 2;
  else if (tmpno == 3) no = 1;
  else no = 0;
  #ifdef USEKDE
  ((KSelectAction *)ACTION("settings_duration"))->setCurrentItem(no);
  #else
  // not supported
  #endif

  // Dice mode
  no = getDocument()->getDiceMode();  
  #ifdef USEKDE
  ((KSelectAction *)ACTION("settings_dice"))->setCurrentItem(no);
  #else
  settingsDice->setCurrentItem(no);
  #endif

  // Ai modes
  flag = getDocument()->getAiMode(1);
  #ifdef USEKDE
  ((KToggleAction *)ACTION("settings_aiyellow"))->setChecked(flag);
  #else
  settingsComputerplayer->setCurrentItem(0,flag,false);
  #endif

  flag = getDocument()->getAiMode(2);
  #ifdef USEKDE
  ((KToggleAction *)ACTION("settings_aired"))->setChecked(flag);
  #else
  settingsComputerplayer->setCurrentItem(1,flag,false);
  #endif
}

// Shareware screen
void KtritocApp::msg_screen()
{
  #ifdef SHAREWARE 
  QString title = i18n("DEMO");
  QString msg   = i18n("This version of the game is a\nDEMO version. You get a FULL\n"
                        "version if you either make a\nvalueable suggestion or bug\n"
                        "report to the author or buy\nit for 0.99$ at\n"
                        "http://www.handago.com or\nhttp://www.heni-online.de\n"
                        );
  QMessageBox::information(this,title,msg,
                          i18n("Ok"),QString::null,QString::null,
                          0 /* default */,0 /* Escape */);
  #endif
}


#ifdef USEKDE
#include "ktritoc.moc"
#endif
