/***************************************************************************
                          ktritoc  -  a KDE game - ktritocview.h
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KTRITOCVIEW_H
#define KTRITOCVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qcanvas.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qcanvas.h>
#include <qtimer.h>
#include <qsize.h>
#include <qpoint.h>

// include files for KDE
#include "mrandom.h"



class KtritocDoc;
class GameIntro;

/** The KtritocView class provides the view widget for the KtritocApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As KtritocView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the KtritocApp class to manipulate and display
 * the document structure provided by the KtritocDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class KtritocView : public QCanvasView
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    KtritocView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~KtritocView();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a KtritocApp instance as a parent
     * widget to get to the window document pointer by calling the KtritocApp::getDocument() method.
     *
     * @see KtritocApp#getDocument
     */
    KtritocDoc *getDocument() const;

    /** Sets the base directory for the grafix */
    void setGrafix(QString dir) {mGrafix=dir;}
  /** Remove all board content */
  void clear();
  /** Draws the full board in its current shape (normally the start board) */
  void drawBoard();
  /** Draws the text sprites for numbering */
  void drawNumbers();
  /** Draws score widget */
  void drawScore();
 /** Draws info widget */
  void drawInfo();
 /** Draws game over sprites  */
  void drawGameOver();

protected slots: 
 /** Draws intro sprites  */
  void drawIntro();

  private:
    /** The drawing canvas */
    QCanvas *mCanvas;
    /** A random generator */
    MRandom mRandom;
    /** Event timer */
    QTimer *mTimer;

    /** The intro object */
    GameIntro *mIntro;

protected: // Protected methods
   /** Draw all board pieces */
  void drawPieces();
  /** Draws the dice */
  void drawDice();

  /** Canvas gets mouse event */
  void contentsMousePressEvent( QMouseEvent *mouse );
  /** Canvas gets resize event */
  void resizeEvent(QResizeEvent *e);

  private:
    /** The parent window */
    QWidget *mParent;
    int mStatus; // Show status
    QString mGrafix;

};

#endif // KTRITOCVIEW_H
