/***************************************************************************
                          ktritoc  -  a KDE game main.cpp
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
  ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ktritoc.h"

#ifdef USEKDE
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>
#include <kdebug.h>


static const char *description =
	I18N_NOOP("=====  KTritoc  =====\n"
            "KTritoc is a nice little boardgame requiring both luck and\n"
            "a good strategy to win against the computer or another\n"
            "player.\n"
            "Note, that there is a Sharp Zaurus 5500 version available!\n"
           );
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE
	
	
static KCmdLineOptions options[] =
{
  // INSERT YOUR COMMANDLINE OPTIONS HERE
  { "d", 0, 0},
  { "debug <level>", I18N_NOOP("Enter debug level"), 0 },
  { 0, 0, 0 }
};
#else // QPE
#include <qpe/qpeapplication.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#undef GRAB_KEYBOARD
#endif

int global_debug;

int main(int argc, char *argv[])
{
  global_debug=0;

  #ifdef USEKDE
  QString v;
  v.setNum(GAME_VERSION,'f',2);
	KAboutData aboutData( "ktritoc", I18N_NOOP("KTritoc"),
		v.latin1(), description, KAboutData::License_GPL,
		"(c) 2002, M. Heni", 0, 0, "ktritoc@heni-online.de");
	aboutData.addAuthor("M. Heni",0, "ktritoc@heni-online.de");
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KApplication app;
 
  if (app.isRestored())
  {
    RESTORE(KtritocApp);
  }
  else 
  {
    KtritocApp *ktritoc = new KtritocApp();
    ktritoc->show();

    //KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
  }

  return app.exec();
  // ------------------------------- QPE -----------------------------
  #else // QPE
  QPEApplication a(argc, argv);
  QTranslator tor( 0 );

  // set the location where your .qm files are in load() below as the last parameter instead of "."
  // for development, use "/" to use the english original as
  // .qm files are stored in the base project directory.
  tor.load( QString("Tritoc.") + QTextCodec::locale(), "." );
  a.installTranslator( &tor );

  #ifdef GRAB_KEYBOARD
  a.grabKeyboard();
  #endif
    
   KtritocApp mainwindow(&a);
  a.setStylusOperation(&mainwindow,QPEApplication::LeftOnly);
  a.setInputMethodHint(&mainwindow,QPEApplication::AlwaysOff);
  a.showMainWidget(&mainwindow,false);


  bool result=a.exec();
  #ifdef GRAB_KEYBOARD
  a.ungrabKeyboard();
  #endif
  return result;

  #endif
}  
