/***************************************************************************
                          ktritoc  -  a KDE game movesprite.h
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MOVESPRITE_H
#define MOVESPRITE_H

#include "mrandom.h"
#include "sprite.h"

/**Inherits the pixmap sprite but introduces movment
  *@author M. Heni
  */

class MoveSprite : public Sprite
{
public:

  MoveSprite(QCanvas *Canvas, QString filename, int frames=1);
  ~MoveSprite();

  /**
    * Rtti for the sprite
    */
  virtual int rtti() const {return 2004;}
  /** Chooses the movement strategy */
  void setMovement(int no,double maxtime = 5.0);
  /** Set destination (if applicaple) */
  void setDestination(double x, double y);
  /** gets destination */
  void getDestination(double &x, double &y);
  /** Defines frame animation , delay=0: stop animation */
  void setAnimation(int delay=1, int type = 0);

protected:
  /**
   * Creates sprite anaimation and movement
   */
  void advance(int phase);
  /** Performs gravity animation */
  void gravity();
  /** Performs linear animation */
  void linear();
  /** Performs linear brownian animation */
  void brownianX();

private: // Private attributes
  /** Movement type */
  int mMovement;
  double mX;
  double mY;
  double mTime;
  double mMaxtime;
  double mDestX;
  double mDestY;
  int mAnimDelay;
  int mAnimCount;
  int mBrownDir;
  int mAnimType;
  MRandom mRandom;
};

#endif
