/***************************************************************************
                          ktritoc  -  a KDE game mrandom.cpp
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
  ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef USEKDE
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#endif

#include "mrandom.h"

bool MRandom::hasSeed = false;

MRandom::MRandom()
{
  setSeed(0);
}
MRandom::~MRandom()
{
}

void MRandom::setSeed(long lngSeed )
{
  #ifdef USEKDE
  mRandom.setSeed(lngSeed);
  #else
  // ONLY one setSeed !!!
  if (hasSeed) return ;
  hasSeed=true;
  time_t t;
  if (lngSeed == 0) // use time and pid
  {
    time(&t);
    srand((unsigned int)t + getpid());
  }
  else
  {
    srand((unsigned int)lngSeed);
  }
  #endif
}

/** returns a long random number 0..upper-1 */
unsigned long MRandom::getLong(unsigned long upper)
{
  #ifdef USEKDE
  return mRandom.getLong(upper);
  #else
  double rnd=(double)rand()/(double)RAND_MAX*(float)upper;
  unsigned long result=(unsigned long)rnd;
  return result;
  #endif
}
/** Returns random double number 0..1 */
double MRandom::getDouble()
{
  #ifdef USEKDE
  return mRandom.getDouble();
  #else
  double rnd=(double)rand()/(double)RAND_MAX;
  return rnd;
  #endif
}
