/***************************************************************************
    Text sprite for the numbers
                          
    copyright            : (C) 2002 by Martin Heni
    email                : ktritoc@heni-online.de
 ***************************************************************************/

#include <math.h>

// Qt includes
#include <qcanvas.h>

#include <qpixmap.h>
#include <qpoint.h>

#include "numbersprite.h"


NumberSprite::NumberSprite(QCanvas *canvas,QString text,int size) :
            QCanvasText(canvas)
{
  setText(text);
  setColor(Qt::yellow);

  if (size>0)
  {
    QFont newfont = font();
    newfont.setPixelSize(size);
    setFont(newfont);
  }

  // z Pos
  setZ(10);
  
  // We immediately show the sprite. 
  show();
}

NumberSprite::~NumberSprite()
{
  // Hide before destruction to make sure it is removed 
  // from all canvas
  hide();
}


/** Returns the text width */
int NumberSprite::width()
{
 return boundingRect().width();
}
/** Returns the text height */
int NumberSprite::height()
{
 return boundingRect().height();
}
/** Sets sprite offset */
void NumberSprite::setOffset(QPoint point){
  mOffset = point;
}
