/***************************************************************************
    Text sprite for the QCanvas demo program
                          
    copyright            : (C) 2002 by Martin Heni
    email                : ktritoc@heni-online.de
 ***************************************************************************/
#ifndef NUMBERSPRITES_H
#define NUMBERSPRITES_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qcanvas.h>
#include <qpoint.h>


/**
 * Number sprite for game board
 *
 * @short A sprite object
 * @author Martin Heni <martin@heni-online.de>
 */
class NumberSprite : public QCanvasText
{
  public:
    /**
     * Construct the sprite
     * @param text - the text to display
     * @param canvas - the canvas
     */
    NumberSprite(QCanvas *Canvas, QString text, int size);

    /**
     * Destructor for the sprite
     */
    ~NumberSprite();

    /**
      * Sets offset of sprite
      */
    void setOffset(QPoint offset);

    /**
     * Rtti for the sprite
     */
    virtual int rtti() const {return 2002;}
  /** Returns the text height */
  int height();
  /** Returns the text width */
  int width();

private: // Private attributes
  /** Sprite offset */
  QPoint mOffset;
};

#endif
