/***************************************************************************
                          ktritoc  -  a KDE game score.h
                             -------------------
    begin                : November 2002
    copyright            : (C) 2002 by M. Heni
    email                : ktritoc@heni-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCORE_H
#define SCORE_H

#include <qobject.h>
#include <qpoint.h>
#include <qcanvas.h>
#ifdef USEKDE
#include <qptrvector.h>
#else
#include <qvector.h>
#define QPtrVector QVector
#endif

#include "mrandom.h"

class Sprite;
class MoveSprite;

/**
  *@author M. Heni
  */

class Score : public QObject
 {
    Q_OBJECT

public: 
  Score(int id);
  ~Score();
  /** Loads sprites for the score */
  void AddScore(QCanvas *canvas,QString number,QString background,QString player,QString dollar);
  /** Delets sprites */
  void clear();
  /** Returns the score */
  int getScore();
  /** Sets the score */
  void setScore(int value);
  /** Sets the position */
  void setOffset(QPoint offset);
  /** Gets the pos'th digit of the value */
  int getDigit(int value,int pos);
  /** Reset score */
  void reset();
  /** Activates or deactivates player active/moving */
  void setPlayerStatus(bool status);
  /** Starts the flying dollar sign */
  void startDollar();

private: // Private attributes
  /** Score  */
  int mScore;
  /* Player id */
  /** Position of widget */
  QPoint mOffset;;
  int mId;
  QPtrVector<Sprite> mNumberSprites;
  Sprite *mBackgroundSprite;
  Sprite *mPlayerSprite;
  MoveSprite *mDollarSprite;
  MRandom mRandom;
};

#endif
