/***************************************************************************
    Collision sprite for the QCanvas demo program
                          
    copyright            : (C) 2002 by Martin Heni
    email                : krtitoc@heni-online.de
 ***************************************************************************/
#ifndef SPRITES_H
#define SPRITES_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qcanvas.h>


/**
 * This sprite demonstrate an ball sprite collision testing
 *
 * @short A sprite object
 * @author Martin Heni <martin@heni-online.de>
 */
class Sprite : public QCanvasSprite
{
  public:
    /**
     * Construct the sprite
     * @param filename - the graphics to load
     * @param canvas - the canvas
     */
    Sprite(QCanvas *Canvas, QString filename, int frames=1);

    /**
     * Destructor for the sprite
     */
    ~Sprite();

    /**
     * Rtti for the sprite
     */
    virtual int rtti() const {return 2003;}

    /* Make protected methods available */
    int width() const {return QCanvasSprite::width();}
    int height() const {return QCanvasSprite::height();} 



    protected:
    /**
     * Load sprite from a pixmap
     */
    bool loadSprite(QString name, int frames);

    /**
     * Creates sprite anaimation and movement
     */
    void advance(int phase);

    private:
};

#endif
